package com.huimv.manage.sys.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.huimv.manage.common.token.TokenSign;
import com.huimv.manage.sys.entity.Group;
import com.huimv.manage.sys.service.IGroupService;
import com.huimv.manage.sys.service.ISysAccountMultilevelService;
import com.huimv.manage.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@CrossOrigin
@RestController
@RequestMapping("/group")
public class SysGroupController {

    @Autowired
    private IGroupService groupService;

    @Autowired
    private ISysAccountMultilevelService accountMultilevelService;

    @PostMapping("/add")
    public Result addGroup (@RequestBody Group group, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        return groupService.addGroup(group,userId);
    }


    @PostMapping("/edit")
    public Result updateGroup( @RequestBody Group group ){
        return groupService.updateGroup( group);
    }

    @RequestMapping("/remove")
    public Result removeGroup( @RequestParam("groupId") Integer groupId) {
        return groupService.removeGroup(groupId);
    }

    @PostMapping("/list")
    public IPage<Group> listGroup(@RequestBody Map map , HttpServletRequest request) {
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        List<Integer> allChildId = accountMultilevelService.getAllChildId(userId);
        return groupService.listGroup(map,allChildId);
    }
}
